'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var language = require('@codemirror/language');
var highlight = require('@lezer/highlight');
var autocomplete = require('@codemirror/autocomplete');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "!WQYQPOOOnQPO'#CfOOQO'#Ck'#CkOOQO'#Cg'#CgQYQPOOOOQO,59Q,59QOuQPO,59QOOQO-E6e-E6eOOQO1G.l1G.l",
  stateData: "!P~O^OSPOS~ORQOSQOTQOUQOVQOXPO~OWTO~PYOWWO~PYOST~",
  goto: "w`PPPPPPPPPPagPPPqXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ LineComment Program Identifier String Name Boolean Number ) ( Application",
  maxTerm: 15,
  nodeProps: [
    ["openedBy", 8,"("],
    ["closedBy", 9,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "%p~R`XY!TYZ!T]^!Tpq!Tst!fxy!tyz!y}!O#O!O!P#a!P!Q#o!Q![#U!c!v$^!v!w$f!w!}$^#R#S%Y#T#o%Y~!YS^~XY!TYZ!T]^!Tpq!T~!iQ#Y#Z!o#h#i!o~!tOU~~!yOX~~#OOW~~#RP!Q![#U~#ZQV~!O!P#a!Q![#U~#dP!Q![#g~#lPV~!Q![#g~#rP!P!Q#u~#zSP~OY#uZ;'S#u;'S;=`$W<%lO#u~$ZP;=`<%l#u~$cPT~#T#o$^~$kQT~!Q![$q#T#o$^~$tQ!O!P$z!Q![$q~$}P!Q![%Q~%VPS~!Q![%Q~%_RR~!Q![%h#R#S%Y#T#o%Y~%mPR~!Q![%h",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 44
});

/// A collection of JavaScript-related
/// [snippets](#autocomplete.snippet).
const snippets = [
    // compare
    autocomplete.snippetCompletion("(${value1} if ${condition} else ${value2})", {
        label: "if ... else",
        type: "keyword"
    }),
    // math
    autocomplete.snippetCompletion("dif(${tag})", {
        label: "dif",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("max(${tag})", {
        label: "max",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("min(${tag})", {
        label: "min",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("avg(${tag})", {
        label: "avg",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("abs(${param})", {
        label: "abs",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("exp(${param})", {
        label: "exp",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("log(${param})", {
        label: "log",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("log10(${param})", {
        label: "log10",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("sqrt(${param})", {
        label: "sqrt",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("pow(${param}, ${degree})", {
        label: "pow",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("hypot(${param}, ${param2})", {
        label: "hypot",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("round(${param})", {
        label: "round",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("floor(${param})", {
        label: "floor",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("ceil(${param})", {
        label: "ceil",
        type: "keyword"
    }),
    // constants 
    autocomplete.snippetCompletion("Pi", {
        label: "Pi",
        type: "constant"
    }),
    autocomplete.snippetCompletion("E", {
        label: "E",
        type: "constant"
    }),
    // trigonometric
    autocomplete.snippetCompletion("sin(${param})", {
        label: "sin",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("asin(${param})", {
        label: "asin",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("sinh(${param})", {
        label: "sinh",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("cos(${param})", {
        label: "cos",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("acos(${param})", {
        label: "acos",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("cosh(${param})", {
        label: "cosh",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("tan(${param})", {
        label: "tan",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("atan(${param})", {
        label: "atan",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("tanh(${param})", {
        label: "tanh",
        type: "keyword"
    }),
];

const mathLanguage = language.LRLanguage.define({
    name: 'math',
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: language.delimitedIndent({ closing: ")", align: false })
            }),
            language.foldNodeProp.add({
                Application: language.foldInside
            }),
            highlight.styleTags({
                Identifier: highlight.tags.variableName,
                Boolean: highlight.tags.bool,
                Name: highlight.tags.name,
                String: highlight.tags.string,
                Number: highlight.tags.number,
                LineComment: highlight.tags.lineComment,
                "( )": highlight.tags.paren
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
function math() {
    return new language.LanguageSupport(mathLanguage, [
        mathLanguage.data.of({
            autocomplete: autocomplete.completeFromList(snippets)
        })
    ]);
}

exports.math = math;
exports.mathLanguage = mathLanguage;
